(function ($) {
  ("use strict");
  jQuery(document).ready(function ($) {
    var self = this;
    var selector = $("#wp-nt-aio-wrapper");

    $(".nt-aio-item-icon").each(function () {
      const appName = $(this).data("appname");
  
       const backgroundIconCustomApp = $(
         `.nt-aio-${appName}[data-appname="${appName}"]`
       ).data("urlicon");
       const backgroundColorCustomApp = $(
         `.nt-aio-${appName}[data-appname="${appName}"]`
       ).data("coloricon");

       $(`.nt-aio-${appName}[data-appname="${appName}"]`).css({
         "--backgroundIconCustomApp": backgroundIconCustomApp
           ? `url(${backgroundIconCustomApp})`
           : 'url("../images/custom-app.svg")',
         "--backgroundColorCustomApp": backgroundColorCustomApp,
       });
    });

    selector.on("click", ".js__nt_aio_active", function () {
      if (selector.hasClass("nt-aio-active")) {
        selector
          .removeClass("nt-aio-active")
          .removeClass("nt-aio-show-list")
          .removeClass("nt-aio-show-popup");
      } else {
        selector.addClass("nt-aio-active").addClass("nt-aio-show-list");
      }
      return false;
    });

    // selector.on("click", ".js__nt_aio_active", function () {
    //   // Toggle the active class
    //   selector.toggleClass("nt-aio-active").toggleClass("nt-aio-show-list");

    //   // If the widget is active, show the list
    //   if (selector.hasClass("nt-aio-active")) {
    //     selector.addClass("nt-aio-show-list");
    //   }

    //   return false;
    // });

    selector.on("click", ".js__nt_aio_item", function () {
      selector.removeClass("nt-aio-show-list");
      $(".nt-aio-popup-active").removeClass("nt-aio-popup-active");
      if (wp_saio_object.style === "redirect") {
        const elementID = $(this).data("target");
        const href = $(this).find('.nt-aio-item-txt').data("content");
        const isMobile = $(this).data("is-mobile");
        if (isMobile && elementID.includes("line")) {
          const lineHref = $(".line-mobile-link").attr("href");
          window.open(lineHref, "_blank");
        }
        window.open(href, "_blank");
        selector.removeClass("nt-aio-active").removeClass("nt-aio-show-list");
      } else {
        $($(this).data("target")).addClass("nt-aio-popup-active");
        selector.addClass("nt-aio-show-popup");
      }
      return false;
    });

    selector.on("click", ".js__nt_aio_close_popup", function () {
      selector.removeClass("nt-aio-show-popup");
      selector.addClass("nt-aio-show-list");
      return false;
    });

    const bottom =
      $("#wp-nt-aio-wrapper").data("bottom") &&
      parseInt($("#wp-nt-aio-wrapper").data("bottom"), 10);
    const widgetPosition = $("#wp-nt-aio-wrapper").data("position");

    var widget = {
      position: {
        left: null,
        right: null,
      },
      tooltip: {
        left: null,
        right: null,
      },
      popup: {
        left: null,
        right: null,
      },
    };

    if (widgetPosition === "left") {
      widget = {
        ...widget,
        position: {
          left: "35px",
          right: "unset",
        },
        tooltip: {
          left: "calc(100% + 10px)",
          right: "unset",
        },
        popup: {
          left: "0",
          right: "unset",
        },
      };
    } else {
      widget = {
        ...widget,
        position: {
          left: "unset",
          right: "35px",
        },
        tooltip: {
          left: "unset",
          right: "calc(100% + 10px)",
        },
        popup: {
          left: "unset",
          right: "0",
        },
      };
    }
    $("#wp-nt-aio-wrapper").css({
      bottom: bottom,
      ...widget.position,
    });

    $(".nt-aio-item-txt").css({
      ...widget.tooltip,
    });

    $(".nt-aio-popup").css({
      ...widget.popup,
    });

    selector.show();
    // handle live preview

    // 1. Enable/Disable Plugin
    $("#wpsaio-enable-plugin-switch").change(function () {
      const isEnable = $(this).prop("checked");
      isEnable ? selector.show() : selector.hide();
    });

    // 2. Widget position
    $(".btn-widget-position").click(function () {
      const position = $(this).val();
      if (position === "left") {
        selector.css({
          left: "35px",
          right: "unset",
        });
        $(".nt-aio-item-txt").css({
          left: "70px",
          right: "unset",
        });
        $(".nt-aio-popup").css({
          left: "0",
          right: "unset",
        });
      } else {
        selector.css({
          right: "35px",
          left: "unset",
        });
        $(".nt-aio-item-txt").css({
          left: "unset",
          right: "70px",
        });
        $(".nt-aio-popup").css({
          left: "unset",
          right: "0",
        });
      }
    });

    // 3. Widget style
    $(".btn-style").click(function () {
      const style = $(this).val();
      wp_saio_object.style = style;
    });

    // 4. Widget tooltip
    $(".btn-tooltip").click(function () {
      const tooltipType = $(this).val();
      $(".nt-aio-item-txt").each(function () {
        if (tooltipType === "appname") {
          const title = $(this).data("title");
          $(this).text(title);
        } else {
          const content = $(this).data("content");
          $(this).text(content);
        }
      });
    });

    // 5. Widget padding from bottom
    $("#wpsaio_bottom_distance").on("input", function () {
      const bottomDistance = $(this).val();
      selector.css({
        bottom: `${bottomDistance}px`,
      });
    });

    // 6. Widget button icon
    $(document).on("click", ".wp_saio_choose_image_btn", function (event) {
      self.renderMediaUploader($(this).data("target"));
    });

    // 7. Widget button image
    $(".btn-button-image").click(function () {
      const buttonImageType = $(this).val();
      const backgroundSize = buttonImageType === "cover" ? "cover" : "60%";
      const buttonBgColor =
        buttonImageType === "cover"
          ? "transparent"
          : $("#wpsaio_button_color").val() || "#007cc4";
      const buttonBgColorAfter = $("#wpsaio_button_color").val() || "#007cc4";
      $(".nt-aio-active").css({
        "--backgroundSize": backgroundSize,
        "--backgroundColor": buttonBgColor,
        "--backgroundColorAfter": buttonBgColorAfter,
      });
    });

    // 8. Widget button bg color
    const handleChangeColor = {
      change: function (event, ui) {
        let buttonImageType = null;
        $(".btn-button-image").each(function () {
          if ($(this).hasClass("active")) {
            buttonImageType = $(this).val();
          }
          return;
        });

        if ( $('.njt-nav-link-active').attr("href") === '#saio-design') {
          $(".nt-aio-active").css({
            "--backgroundColor":
              buttonImageType === "cover" ? "transparent" : ui.color.toString(),
            "--backgroundColorAfter": ui.color.toString(),
          });
        }
       
        const colorPickerId = $(this).closest(".wpsaio-app-input-wrap").data('appname');

        if (colorPickerId?.match(/\d+/)) {
          $(`.wp-saio-icon-${colorPickerId}`).css({
            background: ui.color.toString(),
          });
        }
      },
    };

    if($(".wp_saio_colorpicker").length) {
      $(".wp_saio_colorpicker").wpColorPicker(handleChangeColor);
    }
    
    $(document).on("click", ".saio-btn-app", function (event) {
      if (
        this.parentElement.getAttribute("data-appname").includes("custom-app")
      ) {
        $(".wp_saio_colorpicker").wpColorPicker(handleChangeColor);
      }
    });

    $(".wp-picker-clear").click(function () {
      $(".nt-aio-active").css({
        "--backgroundColor": "#007cc4",
        "--backgroundColorAfter": "#007cc4",
      });
    });

    self.renderMediaUploader = function (target) {
      "use strict";
      var file_frame;

      // If the media frame already exists, reopen it.
      if (undefined !== file_frame) {
        file_frame.open();
        return;
      }

      // Create a new media frame
      file_frame = wp.media({
        title: wp_saio_object.add_media_text_title,
        button: {
          text: wp_saio_object.add_media_text_button,
        },
        multiple: false,
      });
      // When an image is selected in the media frame...
      file_frame.on("select", function () {
        const selection = file_frame.state().get("selection");
        selection.each(function (attachment) {
            attachment = attachment.toJSON();

            if (attachment.id) {
              const file_choosed = attachment.url;
              $("#wp-nt-aio-wrapper").css("--backgroundIcon", `url(${file_choosed})`);
              $(target).val(file_choosed);

              const classPrefix = ".wp-saio-icon-";
              const classSuffix = $(target).attr("id").replace("wpsaio_button_", "").replace("_icon", "").replaceAll("_", "-");
              const imageClass = classPrefix + classSuffix;

              $(imageClass).html('<img src="' + file_choosed + '" alt="Image Preview">');
              
              $(".media-modal-close").click();
            }
        });
      });
      file_frame.open();
    };
  });
})(jQuery);
